// DlgParam.cpp : t@C
//

#include "stdafx.h"
#include "AppSamp.h"
#include "DlgParam.h"

// CDlgParam _CAO

IMPLEMENT_DYNAMIC(CDlgParam, CDialog)

CDlgParam::CDlgParam(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgParam::IDD, pParent)
{

}

CDlgParam::~CDlgParam()
{
	EP_CloseParamTableST();
}

void CDlgParam::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CDlgParam, CDialog)
	ON_BN_CLICKED(IDC_BTN_CANCEL, &CDlgParam::OnBnClickedBtnCancel)
	ON_BN_CLICKED(IDC_BTN_SET, &CDlgParam::OnBnClickedBtnSet)
	ON_BN_CLICKED(IDC_BTN_SAVE, &CDlgParam::OnBnClickedBtnSave)
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
END_MESSAGE_MAP()


// CDlgParam bZ[W nh

BOOL CDlgParam::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ɏǉĂ
	EP_OpenParamTableST( );

	EP_LoadInifileST( &m_sampleTable );

	EP_SetParamToDlgST( this->m_hWnd, &m_sampleTable );

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

void CDlgParam::OnBnClickedBtnSet()
{
	EP_GetParamFromDlgST( this->m_hWnd, &m_sampleTable );
}

void CDlgParam::OnBnClickedBtnCancel()
{
	EP_SetParamToDlgST( this->m_hWnd, &m_sampleTable );
}

void CDlgParam::OnBnClickedBtnSave()
{
	int rc;

	rc = EP_GetParamFromDlgST( this->m_hWnd, &m_sampleTable );
	if (rc < 0) return;

	EP_SaveInifileST( &m_sampleTable );
}

void CDlgParam::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	int data;
	float dataF;
	EP_SetScrollDlgST( this->m_hWnd, pScrollBar->m_hWnd, nSBCode, nPos, &m_sampleTable, &data, &dataF );

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CDlgParam::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	int data;
	float dataF;
	EP_SetScrollDlgST( this->m_hWnd, pScrollBar->m_hWnd, nSBCode, nPos, &m_sampleTable, &data, &dataF );

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}
