#include <windows.h>

#include "Resource.h" /* GUĨ\[Xt@CK{ */
#include "EasyPara_Sample.h"


#define INI_SCTN_SAMPLE "ZNV"

/* CfbNX擾p` */
static EP_SampleTable *g_dmyPrm = 0;
#define EPG_ADR_BASE(n) (g_dmyPrm->n) /* GET_ADDR, GET_ADDR_STR_MAX̒`ɕK{ */
#define EPG_ADDR(n)         GET_ADDR(n)         /* l̏ꍇ̃e[ũCfbNX */
#define EPG_ADDR_STR_MAX(n) GET_ADDR_STR_MAX(n) /* ̏ꍇ̍ő啶(32bit)ƃe[ũCfbNX */

static EP_ParamTable g_EP_ParamTbl[] = {
/*  p[^^Cv,      ZNV,    L[,                     ftHgl,          ŏl, ől,\ނւ̲ޯ, _CAÕRg[ID, ėp|C^(svp[^^Cvł͏ȗ)  */
	{ EP_TYPE_ED_LONG,       INI_SCTN_SAMPLE, "int^",                    "0",                   "0",    "3",   EPG_ADDR( sample01 ),  IDC_EDT_SAMPLE01 },
	{ EP_TYPE_CHKBOX_0,      INI_SCTN_SAMPLE, "ΏCheck-box",            "1",                   "0",    "10",  EPG_ADDR( sample02 ),  IDC_CHK_SAMPLE02 },
	{ EP_TYPE_CMB_LONG,      INI_SCTN_SAMPLE, "int^-ΏCombo-box",      "1",                   "0",    "10",  EPG_ADDR( sample03 ),  IDC_CMB_SAMPLE03 },
	{ EP_TYPE_CMB_FLOAT,     INI_SCTN_SAMPLE, "float^-ΏCombo-box",    "0.2",                 "0",    "10",  EPG_ADDR( sample10 ),  IDC_CMB_SAMPLE10, "0.1\n0.15\n0.2\n0.25\n0.3" },
	{ EP_TYPE_CMB_STRING,    INI_SCTN_SAMPLE, "char^-ΏCombo",   "RED",                 "0",    EPG_ADDR_STR_MAX( sample09 ), IDC_CMB_SAMPLE09, "RED\nGREEN\nBLUE" },
	{ EP_TYPE_ED_FLT_EN02,   INI_SCTN_SAMPLE, "float^Ew\L02",      "0.1",                 "0.0",  "1.0", EPG_ADDR( sample04 ),  IDC_EDT_SAMPLE04 },
	{ EP_TYPE_ED_FLOAT,      INI_SCTN_SAMPLE, "float^",                  "0.1234",              "0.0",  "1.0", EPG_ADDR( sample05 ),  IDC_EDT_SAMPLE05 },
	{ EP_TYPE_ED_STRING,     INI_SCTN_SAMPLE, "char^",             "C:\\IA_CLASS\\IAESP", "0",    EPG_ADDR_STR_MAX( sample06 ), IDC_EDT_SAMPLE06 },
	{ EP_TYPE_SLID_LONG,     INI_SCTN_SAMPLE, "XCho[()",       "10",                  "3",    "30",  EPG_ADDR( sample07 ),  IDC_SLID_SAMPLE07 },
	{ EP_TYPE_ED_LONG,       INI_SCTN_SAMPLE, "XCho[()",       "10",                  "3",    "30",  EPG_ADDR( sample07 ),  IDC_EDT_SAMPLE07 },
	{ EP_TYPE_SLID_FLT_D100, INI_SCTN_SAMPLE, "ײް(float)-0.01", "0.2",                 "0.0",  "1.1", EPG_ADDR( sample08 ),  IDC_SLID_SAMPLE08 },
	{ EP_TYPE_ED_FLOAT,      INI_SCTN_SAMPLE, "ײް(float)-0.01", "0.2",                 "0.0",  "1.1", EPG_ADDR( sample08 ),  IDC_EDT_SAMPLE08 },
	{ EP_TYPE_SCRL_LONG,     INI_SCTN_SAMPLE, "۰ް()",         "10",                  "3",    "30",  EPG_ADDR( sample11 ),  IDC_SCRL_H_SAMPLE11 },
	{ EP_TYPE_ED_LONG,       INI_SCTN_SAMPLE, "۰ް()",         "10",                  "3",    "30",  EPG_ADDR( sample11 ),  IDC_EDT_SAMPLE11 },
	{ EP_TYPE_SCRL_LONG,     INI_SCTN_SAMPLE, "c۰ް()",         "15",                  "3",    "30",  EPG_ADDR( sample12 ),  IDC_SCRL_V_SAMPLE12 },
	{ EP_TYPE_ED_LONG,       INI_SCTN_SAMPLE, "c۰ް()",         "15",                  "3",    "30",  EPG_ADDR( sample12 ),  IDC_EDT_SAMPLE12 },
	{ EP_TYPE_CMB_STRING_ID, INI_SCTN_SAMPLE, "int^--ΏCmb-box", "3",                   "0",    "0",   EPG_ADDR( sample13 ),  IDC_CMB_SAMPLE13, "\nx1\nx2\n@\1\n@\2" },
	{ EP_TYPE_CMB_LONG,      INI_SCTN_SAMPLE, "int^-ΏList-box",       "1",                   "0",    "10",  EPG_ADDR( sample03L ),  IDC_LST_SAMPLE03 },
	{ EP_TYPE_CMB_FLOAT,     INI_SCTN_SAMPLE, "float^-ΏList-box",     "0.2",                 "0",    "10",  EPG_ADDR( sample10L ),  IDC_LST_SAMPLE10, "0.1\n0.15\n0.2\n0.25\n0.3" },
	{ EP_TYPE_CMB_STRING,    INI_SCTN_SAMPLE, "char^-ΏList",    "GREEN",               "0",    EPG_ADDR_STR_MAX( sample09L ), IDC_LST_SAMPLE09, "RED\nGREEN\nBLUE" },
	{ EP_TYPE_CMB_STRING_ID, INI_SCTN_SAMPLE, "int^--ΏListBox", "3",                   "0",    "0",   EPG_ADDR( sample13L ),  IDC_LST_SAMPLE13, "\nx1\nx2\n@\1\n@\2" },
	{ EP_TYPE_CMB_SEL_LONG,  INI_SCTN_SAMPLE, "int^-I-ΏCmb-box",   "10000",               "0",    "0",   EPG_ADDR( sample14 ),  IDC_CMB_SAMPLE14, "0\n100\n10000\n1000000" },
	{ EP_TYPE_LST_MULTI_UCH, INI_SCTN_SAMPLE, "uchar^-ΏList-box",     "0;2",                 "0",    EPG_ADDR_STR_MAX( sample15 ),  IDC_LST_SAMPLE15, "0\n100\n10000\n1000000" },
};

/* GET_ADDR, GET_ADDR_STR_MAX̒`폜(̌ɕʃe[uݒ\) */
#undef EPG_ADDR_STR_MAX
#undef EPG_ADDR
#undef EPG_ADR_BASE


static int ep_id01; /* p[^ID(EP_OpenParamTableST̖߂l) */

/* bp[֐Q */
void EP_OpenParamTableST( void ) { ep_id01 = EP_OpenParamTable( sizeof(g_EP_ParamTbl) / sizeof(EP_ParamTable), g_EP_ParamTbl, "HKEY_CURRENT_USER\\Software\\paratest"/*".\\sample.ini"*/, 0 ); }
void EP_CloseParamTableST( void ) { EP_CloseParamTable( ep_id01 ); }
int EP_LoadInifileST( EP_SampleTable *sampleTable )                { return( EP_LoadInifile(     ep_id01,       sampleTable ) ); }
int EP_SaveInifileST( EP_SampleTable *sampleTable )                { return( EP_SaveInifile(     ep_id01,       sampleTable ) ); }
int EP_SetParamToDlgST( HWND hwnd, EP_SampleTable *sampleTable )
{
	int rc;
	rc = EP_SetParamToDlg( ep_id01, hwnd, sampleTable );
//	if (rc < 0) return( rc );
//	rc = EP_SetListToDlg( ep_id01, IDC_CMB_SAMPLE09, "Red\nGreen\nBlue", sampleTable ); /* "L[09"̍ڕύX */
//	if (rc < 0) return( rc );
//	rc = EP_SetListToDlg( ep_id01, IDC_CMB_SAMPLE10, "0.01\n0.02\n0.03", sampleTable ); /* "L[09"̍ڕύX */
	return( rc );
}
int EP_GetParamFromDlgST( HWND hwnd, EP_SampleTable *sampleTable ) {
	int rc;
	rc = EP_GetParamFromDlg( ep_id01, hwnd, sampleTable );
	if (rc < 0) return( rc );
	rc = EP_SetParamToDlgST( hwnd, sampleTable );
	return( rc );
}
int EP_SetScrollDlgST( HWND hwnd, HWND pScrollBar, int nSBCode, UINT nPos, EP_SampleTable *sampleTable, int *data, float *dataF ) { return( EP_SetScrollDlg( ep_id01, hwnd, pScrollBar, nSBCode, nPos, sampleTable, data, dataF ) ); }

